
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Python学习-18.Python中的错误处理（三） / 憋错料</title>

    <meta name="description" content="Python学习-18.Python中的错误处理（三） 在某些情况下,我们需要定义自己的异常并且抛出 先定义一个错误: 1 class MyError(BaseException): 2 def __init__(self): 3 pass 上面定义了一个叫MyError的类,继承自BaseException.在Python中,所有的错误都继承自BaseException,相当于C#中的所有异常都继承自Exception.接下来定义了一个空构造函数. 那么接下来怎样抛出这个异常呢? 在Python中,使用raise关键字,相当于C#中的throw.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Python学习-18.Python中的错误处理（三）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在某些情况下，我们需要定义自己的异常并且抛出</p>
<p>先定义一个错误：</p>
<pre>1 class MyError(BaseException):
2     def __init__(self):
3         pass</pre>
<p>上面定义了一个叫MyError的类，继承自BaseException。在Python中，所有的错误都继承自BaseException，相当于C#中的所有异常都继承自Exception。接下来定义了一个空构造函数。</p>
<p>那么接下来怎样抛出这个异常呢？</p>
<p>在Python中，使用raise关键字，相当于C#中的throw。</p>
<pre>1 raise MyError()</pre>
<p>这样就可以抛出异常了。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 11:18:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Python学习-18.Python中的错误处理（三）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N8qG80.html" rel="bookmark">python学习之web中的html</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Web概述web起源web特点1.易导航和图形化界面2.与平台无关3.分布式结构4.动态性5.交互性 html 网页结构 HTML(Hyper Text Mark-up Language )即是超文本标记语言, 通过使用标记标签来描述页面文档结构和表现形式的一种语言,再由浏览器进行解析,然后把结果展示在网页上.?超文本指的是超链接?标记指的是标签1).HTML文件用编辑器打开显示的是文本,可以用文 本的方式编辑.2). HTML文件用浏览器打开,浏览器会按照标签描述内容将文件渲染成网页,显示的网			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyNxO3.html" rel="bookmark">总结：Python学习 和 Python与C&sol;C&plus;&plus;交互</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇仅仅是Python的学习和Python和C++数据对接过程中的一些总结. 由于工作的需要,用一周的时间学习 Python. Python是基于C实现的一门解释型语言,由于其易用性,俘获了不少开发者和运维的心.据说,Python 在科学计算领域,逐步吞噬着古老语言 Fortran的份额.这门语言是Google的第二语言,国内的知乎,豆瓣,都使用纯Python开发.Python的官方网站:http://www/python.org. 为了逐步完善的我们的数据库驱动服务,我们需要为客户提供更多,更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02NAXD0.html" rel="bookmark">Python学习教程（Python学习路线&plus;Python学习视频）：Python数据结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python学习教程(Python学习路线+Python学习视频):Python数据结构   数据结构引言:   数据结构是组织数据的方式,以便能够更好的存储和获取数据.数据结构定义数据之间的关系和对这些数据的操作方式.数据结构屏蔽了数据存储和操作的细节,让程序员能更好的处理业务逻辑,同时拥有快速的数据存储和获取方式. 在这篇文章中,你将了解到多种数据结构以及这些数据结构在Python中实现的方式.    抽象数据类型和数据结构 数据结构是抽象数据类型(ADT)的实现,通常,是通过编程语言提供的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMyBvL0.html" rel="bookmark">Python学习-16&period;Python中的错误处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然叫错误,但跟 C# 中的异常是一回事.只不过 Python 中叫错误(Error)而 C# 中叫异常(Exception). 先手工产生一个异常: 1 file = open('','r') 上面一句由于路径是空路径,因此文件肯定是不存在的,执行这一句会引发 FileNotFoundError 这个错误. 既然是错误的,程序也停止了,这是我们不希望的,因此得想办法处理一下. 在 Python 中,异常处理使用 try.except.finally 这三个关键字. 修改代码如下: 1 path			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lDZVX0.html" rel="bookmark">PYTHON 学习入门--Eclipse中安装pydev插件及调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				运行程序 运行 Python 源程序,有两种方法,以 example.py 为例: example.py代码: [python] view plaincopyprint? #!/usr/bin/env python # -*- coding:utf-8 -*- # ithomer.net a = 1 def display(): print(&quot;hello ithomer&quot;) global a print(&quot;a = %d&quot; % a) a = 2 print(&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzoJGk0.html" rel="bookmark">Python学习 之 Python入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第二章 Python入门 2.1 环境安装 2.1.1 下载解释器: py2.7.16 (2020年官方不再维护) py3.6.8 (推荐安装) 1.下载解释器一定去官网下载,https://www.python.org 2.选择 python3 的版本下载 ? 3.下载 python3 的64位安装包 ? 4.选择 python2 的版本下载 ? 5.下载 python2 的64位安装包 2.1.2 安装解释器Python36 ? 1.点击下载好的安装包,弹框页面中先勾选上&quot;添加到环境变量&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pRekJ0.html" rel="bookmark">Python学习&lpar;一&rpar; Python安装配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我本身是Java程序猿,听说Python很强大,所以准备学习一下Python,虽说语言都是相同的,但java跟python肯定还是有区别的.希望在此记录一下自己的学习过程. 目前,Python分2.X版本和3.X版本.我选择的是Python2.x版本.为了快速学习Python的WEB开发,我选择的Python的WEB开发框架是Django.Django有个好处就是自带了后台管理系统. 第一步,下载: 因本人使用的电脑操作系统是Windows7 64位,所以选择下载Python的windows安装			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kWDRp0.html" rel="bookmark">Python基础教程：Python学习视频Python让你敲的代码不再是造轮子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你敲的代码是在造轮子?那就学Python呗!_Python基础教程 Bruce大神说&quot; 人生苦短,我用Python &quot;. 从公司角度而言: 国内基于Python创业成功的案例不在少数,豆瓣.知乎.果壳,全栈都是 Python,大家对Python自然有信心.并且从这几家公司出来的程序员与 CTO,创业的话一般都会选择Python. 从开发者个人角度而言: 计算机语言只是用来达成目的工具,?各种强大的第三方库,拿来就能用才是王道,让程序替代我们执行一些枯燥繁琐的工作.?至于句式是否优美.能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QXVwN3.html" rel="bookmark">【Python学习】Python 基础语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 一.Python基础语法 1.1 第一个Python程序 1.1.1 交互式编程 1.1.2 脚本式编程 1.2 Python标识符 1.3 Python保留字 1.4 行和缩进 1.5 多行语句 1.6 Python 引号 1.7 Python注释 1.8 Python空行 1.9 print输出 Python 基础语法 1.1 第一个python程序 1.1.1 交互式编程 交互式编程不需要创建脚本文件,是通过 Python 解释器的交互模式进来编写代码. linux上你只需要在命令行			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xzzB4.html" rel="bookmark" class="title">SpringMVC中使用&commat;ResponseBody注解标注业务方法，将业务方法的返回值做成json输出给页面</a>
					<div>
						导包: 除了一些spring的包之外,还需要jackson-annotations.jar , jackson-core.jar , jackson-databind.jar 这三个包 开启@Resp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eA2oD0.html" rel="bookmark" class="title">下边就是这样的</a>
					<div>
						﻿﻿ http://www.ebay.com.au/cln/rkoghou0_6163/-/181578735018/20150219 http://www.ebay.com.au/cln/rkogh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4APbLd3.html" rel="bookmark" class="title">树链剖分 模板</a>
					<div>
						关于树链剖分 模板: 1 const int MAXN = 20010; 2 struct Edge 3 { 4 int to,next; 5 } edge[MAXN*2]; 6 int head[M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXzWL3.html" rel="bookmark" class="title">&amp;lt&semi;极客学院&amp;gt&semi;视频教程学习笔记－iOS中CALayer的使用</a>
					<div>
						&lt;1&gt;CALayer简介 1.CALayer一般作为UIView的容器而使用. 2.CALayer是一个管理者图片载体(image-based content)的层结构 3.直接修改单独创 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RY9KRM.html" rel="bookmark" class="title">jquery&comma;fn&comma;extend和jquery&period;extend</a>
					<div>
						1 把jquery看成是一个类,jquery.extend()是扩展这个类的静态方法,也即是扩展的全局函数,扩展的方法只跟这个类本身有关,跟具体的jquery这个类的实例化对象无关. 例如:$.eac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wR9A10.html" rel="bookmark" class="title">vCenter Web Client安装步骤</a>
					<div>
						第一步.安装vCenter Web Client 第二步.添加角色--&gt;安装&quot;桌面体验&quot;安装完毕重启服务器(Server2012内置Flash) 第三步.前提必须连网,--& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyB5VM.html" rel="bookmark" class="title">linux中的命名管道FIFO</a>
					<div>
						匿名管道pipe前面已经说过了,接下来就说命名管道FIFO: 我们可以使用以下函数之一来创建一个命名管道,他们的原型如下:#include &lt;sys/types.h&gt;#include &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvYXl3.html" rel="bookmark" class="title">Java记录 -21- 访问控制符</a>
					<div>
						Java 访问控制符 访问修饰符(access modifier) 1).public 公共的:被public 所修饰的属性和方法可以被所有类访问: 2).protected 受保护的:被protec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8Oxy3.html" rel="bookmark" class="title">悼念松茸</a>
					<div>
						&quot;替叔叔阿姨发的一篇告示--左邻右舍们,让我们团结友爱,让整个社区和谐起来吧!&quot; 松茸是我的一名爱犬的名字,是雌性泰迪,她瘦小的身躯已经陪伴我们老两口整整10年啦. 她给我们这些年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rkN8l4.html" rel="bookmark" class="title">synzhronized原理</a>
					<div>
						1.java中的每个对象都可作为锁,有三种表现形式: 对于普通方法,锁的是当前this对象. 对于静态方法,锁的是class对象 对于方法块,锁的是synchronized指定的对象. 2.JVM基于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ZL5A0.html" rel="bookmark" class="title">&lbrack;VC6&rsqb;ONMESSAGE&lpar;&rpar;宏编译时出现&amp;quot&semi;sytax error &semi;&amp;quot&semi;错误时</a>
					<div>
						自定义消息时编译出错,经排查,在定义消息的头文件里 1 #define WM_XXX (WM_USER+1000); 最后多加了一个分号引起. 吐血.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aYlpk0.html" rel="bookmark" class="title">词典的实现&lpar;1&rpar;--Map的底层实现</a>
					<div>
						1,词典是这样的一种数据结构:它能根据给定的键(索引值,key)来查找其对应的值(value)是否存在,在JAVA中主要由java.util.HashMap来完成该功能.如电话本就像一部词典,其中名字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODoZX4.html" rel="bookmark" class="title">多线程之解决数据的重复设置和重复取出</a>
					<div>
						class Message{ private String title; private String content; private boolean flag = true; //flag ==  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDyRN70.html" rel="bookmark" class="title">【网络基础】地址解析协议（ARP协议）简介</a>
					<div>
						地址解析协议: 即ARP协议,是根据IP地址获取物理地址的一个TCP/IP协议 功能: 主机将ARP请求广播到网络上的所有主机,并接收返回消息,确定目标IP地址的物理地址,同时将IP地址和硬件地址存入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022oDB0.html" rel="bookmark" class="title">java nio 通道&lpar;二&rpar;</a>
					<div>
						本文章来源于我的个人博客: java nio 通道(二) 一,文件通道 文件通道总是堵塞式的,因此不能被置于非堵塞模式. FileChannel对象是线程安全的.多个进程能够在同一个实例上并发调用方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXv1Yz3.html" rel="bookmark" class="title">VR界的小米科技，互联网的又一颗冉冉新星</a>
					<div>
						原文标题:VR界的小米科技,互联网的又一颗冉冉新星 HYPEREAL是一家创建于前年下半年的,是少数能够拥有位置识别机制.独立软件开发工具包.优质产品团队以及内容团队的初创企业.团队队的主要成员均是名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm9BZKM.html" rel="bookmark" class="title">蓝桥杯-移动距离</a>
					<div>
						移动距离 X星球居民小区的楼房全是一样的,并且按矩阵样式排列.其楼房的编号为1,2,3...当排满一行时,从下一行相邻的楼往反方向排号.比如:当小区排号宽度为6时,开始情形如下: 1 2 3 4 5  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KjEzJM.html" rel="bookmark" class="title">Linux下切换用户</a>
					<div>
						0x01 使用命令[su username] 这种方法能切换普通用户和root用户 0x02 从普通用户切换到root用户,还可以使用命令[sudo su] 0x03 su 是switch user的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wN57V0.html" rel="bookmark" class="title">sql语句中left join和inner join中的on与where的区别分析</a>
					<div>
						关于SQL SERVER的表联接查询INNER JOIN .LEFT JOIN和RIGHT JOIN,经常会用到ON和WHERE的条件查询,以前用的时候有时是凭感觉的,总是没有搞清楚,今日亲自测试了下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vXKEjM.html" rel="bookmark" class="title">关于用bootstrap显示查询的后台数据</a>
					<div>
						PrintWriter pw = response.getWriter(); pw.println(sb); pw.flush(); 由于用bootstrap查询数据,页面需要自身返回bootstra ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
